class Coda:

    def __init__(self):
        self.array = [0]
        self.inizio = 0
        self.prossimo = 0

    def enqueue(self, value):
        # copiare l'array nel caso sia pieno
        if self.full():
            self.copia()
        self.array[self.prossimo] = value
        n = len(self.array)
        self.prossimo = (self.prossimo + 1) % n

    def dequeue(self):
        # assumiamo contenga almeno un elemento
        value = self.array[self.inizio]
        self.array[self.inizio] = 0
        n = len(self.array)
        self.inizio = (self.inizio + 1) % n
        return value

    def copia(self):
        n = len(self.array)
        nuova_dim = 2 * n
        nuovo_array = [0] * nuova_dim
        # copiamo gli n-1 elementi della coda
        # nelle posizioni da 0 a n-2 del nuovo array
        for i in range(0, n-1):
            pos = (self.inizio + i) % n
            nuovo_array[i] = self.array[pos]
        self.array = nuovo_array
        self.inizio = 0
        self.prossimo = n - 1

    def full(self):
        n = len(self.array)
        # la coda inizia una posizione dopo (modulo n)
        # il prossimo posto libero
        return self.inizio == (self.prossimo + 1) % n

    def empty(self):
        return self.inizio == self.prossimo

    def __str__(self):
        s = ""
        n = len(self.array)
        i = self.inizio
        while i != self.prossimo:
            s += str(self.array[i]) + " "
            i = (i + 1) % n
        return s
