# classe nodo per i nodi della lista
class Nodo:

    def __init__(self, value, succ):
        self.value = value
        self.succ = succ


# classe stack implementata con lista
# concatenata singola
class Stack:

    def __init__(self):
        self.testa = None

    def push(self, value):
        nuovo_nodo = Nodo(value, self.testa)
        self.testa = nuovo_nodo

    def pop(self):
        # assumiamo stack non vuoto
        nodo = self.testa
        self.testa = self.testa.succ
        return nodo.value

    def peek(self):
        # assumiamo stack non vuoto
        return self.testa.value

    def empty(self):
        return self.testa is None

    def __str__(self):
        s = "top -> "
        nodo_corrente = self.testa
        while nodo_corrente is not None:
            s += str(nodo_corrente.value) + " "
            nodo_corrente = nodo_corrente.succ
        return s


class Coda:

    def __init__(self):
        self.A = Stack()
        self.B = Stack()

    def enqueue(self, value):
        self.B.push(value)

    def dequeue(self):
        if self.A.empty():
            while not self.B.empty():
                self.A.push(self.B.pop())
        return self.A.pop()

    def empty(self):
        return self.A.empty() and self.B.empty()
